%define anolis_release 1
%global base_version 2.21
Name:           perl-threads
Epoch:          1
Version:        2.27
Release:        %{anolis_release}%{?dist}
Summary:        Perl interpreter-based threads
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/threads
Source0:        https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/threads-%{base_version}.tar.gz
# Unbundled from perl 5.28.0
Patch0:         threads-2.21-Upgrade-to-2.22.patch
# Unbundled from perl 5.32.0
Patch1:         threads-2.21-Upgrade-to-2.25.patch
# Unbundled from perl 5.34.0
Patch2:         threads-2.25-Upgrade-to-2.26.patch
# Unbundled from perl 5.35.11
Patch3:         threads-2.26-Upgrade-to-2.27.patch
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
# Run-time:
BuildRequires:  perl(Carp)
BuildRequires:  perl(overload)
BuildRequires:  perl(XSLoader)
# Tests only:
BuildRequires:  perl(blib)
BuildRequires:  perl(Cwd)
BuildRequires:  perl(ExtUtils::testlib)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(Hash::Util)
BuildRequires:  perl(IO::File)
BuildRequires:  perl(POSIX)
BuildRequires:  perl(Test::More)
# Optional tests:
BuildRequires:  perl(Thread::Queue)
BuildRequires:  perl(Thread::Semaphore)
BuildRequires:  perl(threads::shared)
Requires:       perl(Carp)

%{?perl_default_filter}

%description
Since Perl 5.8, thread programming has been available using a model called
interpreter threads which provides a new Perl interpreter for each thread,
and, by default, results in no data or state information being shared
between threads.

(Prior to Perl 5.8, 5005threads was available through the "Thread.pm" API.
This threading model has been deprecated, and was removed as of Perl 5.10.0.)

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q -n threads-%{base_version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
chmod -x examples/*

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -delete
%{_fixperms} $RPM_BUILD_ROOT/*

%check
unset GIT_DIR PERL_BUILD_PACKAGING PERL_CORE PERL_RUNPERL_DEBUG \
    PERL5_ITHREADS_STACK_SIZE RUN_MAINTAINER_TESTS
make test

%files
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/threads*
%{_mandir}/man3/*

%files doc
%doc Changes examples README

%changelog
* Thu Feb 09 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:2.27-1
- remove versioned MODULE_COMPAT_ requires
- update to version 2.27

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:2.21-2
- rebuild with perl 5.36.0

* Tue Mar 08 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:2.21-1
- Init from upstream version 2.21

